.\" Copyright (C) 1993 David Metcalfe (david@prism.demon.co.uk)
.\"
.\" Permission is granted to make and distribute verbatim copies of this
.\" manual provided the copyright notice and this permission notice are
.\" preserved on all copies.
.\"
.\" Permission is granted to copy and distribute modified versions of this
.\" manual under the conditions for verbatim copying, provided that the
.\" entire resulting derived work is distributed under the terms of a
.\" permission notice identical to this one
.\" 
.\" Since the Linux kernel and libraries are constantly changing, this
.\" manual page may be incorrect or out-of-date.  The author(s) assume no
.\" responsibility for errors or omissions, or for damages resulting from
.\" the use of the information contained herein.  The author(s) may not
.\" have taken the same level of care in the production of this manual,
.\" which is licensed free of charge, as they might when working
.\" professionally.
.\" 
.\" Formatted or processed versions of this manual, if unaccompanied by
.\" the source, must acknowledge the copyright and authors of this work.
.\"
.\" References consulted:
.\"     Linux libc source code
.\"     Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991)
.\"     386BSD man pages
.\" Modified Sat Jul 24 16:09:49 1993 by Rik Faith (faith@cs.unc.edu)
.\" Modified 11 June 1995 by Andries Brouwer (aeb@cwi.nl)
.\" Modified 22 July 1996 by Andries Brouwer (aeb@cwi.nl)
.\" If a Debian maintainer sees this: the current Debian page
.\" shows an incorrect struct dirent.
.\"
.TH READDIR 3  "22 April 1996" "" "Linux Programmer's Manual"
.SH NAME
readdir \- read a directory
.SH SYNOPSIS
.nf
.B #include <sys/types.h>
.sp
.B #include <dirent.h>
.sp
.BI "struct dirent *readdir(DIR *" dir );
.fi
.SH DESCRIPTION
The \fBreaddir()\fP function returns a pointer to a dirent structure
representing the next directory entry in the directory stream pointed
to by \fIdir\fP.  It returns NULL on reaching the end-of-file or if
an error occurred.
.PP
The data returned by \fBreaddir()\fP is overwritten by subsequent
calls to \fBreaddir()\fP for the same directory stream.
.PP
According to POSIX, the
.I dirent
structure contains a field
.I "char d_name[]"
of unspecified size, with at most
.B NAME_MAX
characters preceding the terminating null character.
Use of other fields will harm the portability of your programs.
.SH "RETURN VALUE"
The \fBreaddir()\fP function returns a pointer to a dirent structure, or
NULL if an error occurs or end-of-file is reached.
.SH "ERRORS"
.TP
.B EBADF
Invalid directory stream descriptor \fIdir\fP.
.SH "CONFORMING TO"
SVID 3, POSIX, BSD 4.3
.SH "SEE ALSO"
.BR read "(2), " opendir "(3), " closedir "(3), " rewinddir (3),
.BR seekdir "(3), " telldir "(3), " scandir (3)
